//+------------------------------------------------------------------+
//|                                                  MACD Sample.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+

extern double TakeProfit    =  50;
extern double Lots          = 0.1;
extern double Media_2  =  20;
extern double Media_3  =  65;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   double Ma2, Ma3;
   double Ma2_Prev, Ma3_Prev;
   int cnt, ticket, total;
// initial data checks
// it is important to make sure that the expert works with a normal
// chart and the user did not make any mistakes setting external 
// variables (Lots, StopLoss, TakeProfit, 
// TrailingStop) in our case, we check TakeProfit
// on a chart of less than 100 bars
   if(Bars<100)
     {
      Print("bars less than 100");
      return(0);  
     }
   if(TakeProfit<10)
     {
      Print("TakeProfit less than 10");
      return(0);  // check TakeProfit
     }
// to simplify the coding and speed up access
// data are put into internal variables
   
   Ma2       = iMA(NULL,0,Media_2,0,MODE_EMA,PRICE_CLOSE,0);
   Ma3       = iMA(NULL,0,Media_3,0,MODE_EMA,PRICE_CLOSE,0);
   Ma2_Prev  = iMA(NULL,0,Media_2,0,MODE_EMA,PRICE_CLOSE,1);
   Ma3_Prev  = iMA(NULL,0,Media_3,0,MODE_EMA,PRICE_CLOSE,1);
      
   total=OrdersTotal();
   if(total<1) 
     {
      // no opened orders identified
      if(AccountFreeMargin()<(1000*Lots))
        {
         Print("We have no money. Free Margin = ", AccountFreeMargin());
         return(0);  
        }
      // check for long position (BUY) possibility
      if(Close[-1] < Ma3_Prev && Close[0] > Ma3 && Ma2 > Ma3)
        {
         ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,NULL,NULL,NULL,"20_65",16384,0,Green);
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
           }
         else Print("Error opening BUY order : ",GetLastError()); 
         return(0); 
        }
      // check for short position (SELL) possibility
       if(Close[-1] > Ma3_Prev && Close[0] < Ma3 && Ma2 < Ma3)
        {
         ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,NULL,NULL,NULL,"0_65",16384,0,Red);
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
           }
         else Print("Error opening SELL order : ",GetLastError()); 
         return(0); 
        }
      return(0);
     }
  
   for(cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL &&   // check for opened position 
         OrderSymbol()==Symbol())  // check for symbol
        {
         if(OrderType()==OP_BUY)   // long position is opened
           {
            // should it be closed?
            if( (Close[-1] > Ma3_Prev && Close[0] < Ma3)
             || (Close[-1] > Ma2_Prev && Close[0] < Ma2)
              )
                {
                 OrderClose(OrderTicket(),OrderLots(),Bid,0,Violet); // close position
                 return(0); // exit
                }
            }
         else // go to short position
           {
            // should it be closed?
            if( (Close[-1] < Ma3_Prev && Close[0] > Ma3)
             || (Close[-1] > Ma2_Prev && Close[0] > Ma2)
              )
              {
               OrderClose(OrderTicket(),OrderLots(),Ask,0,Violet); // close position
               return(0); // exit
              }
            
           }
        }
     }
   return(0);
  }
// the end.